/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2012. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
define(["dojo/_base/lang", 
        "dojox/encoding/base64",
	     "dojo/_base/xhr"], function(lang, dce, xhr){
    lang.getObject("com.ibm.mobile.appcenter.Connection", true);
    
    com.ibm.mobile.appcenter.Connection = {    		
    		
    		_stringToByteArray: function(pString) {    			
    			var b = [];
    			for(var i = 0; i < pString.length; ++i){
    				b.push(pString.charCodeAt(i));
    			}
    			return b; 			
    		},
    		
    		_getBase64Auth: function(pUsername, pPassword) {    			
    			var source = pUsername + ":" + pPassword;
    			var sourceBytes = this._stringToByteArray(source);    
    			var ret = "Basic " + dce.encode(sourceBytes);
    			return ret; 			
    		},
    		
    		getInstalledApplicationListURL: function(pServerURL, pDeviceId) {
    			return pServerURL + 
    				"service/device/" + 
    				pDeviceId + "/package";
    		},
    		
    		
    		getPingPath: function(pServerURL) {
    			return pServerURL + "service/auth";
    		},
    		
    		getApplicationVersionsListURL: function(pServerURL, pApplication) {
    			return pServerURL + 
  	          			"service/directory/" + 
  	          			pApplication.expkg;
    		},
    		
    		_getApplicationIconURLPrefix: function(pForApp, pDeviceId) {
            	for (var urlIdx = 0; urlIdx < pForApp.url.length; urlIdx++) 
            		if (pForApp.url[urlIdx].rel == "icon") 
            			return  "service/icons/" + 
            	          	     pForApp.url[urlIdx].value;
            	return null;
    		},
    		
    		getApplicationIconURL: function(pServerURL, pForApp, pDeviceId) {
    			var iconUrl =  this._getApplicationIconURLPrefix(pForApp, pDeviceId);
    			if (iconUrl != null)
    			  return pServerURL + iconUrl; 
    			return null;
    		},
    		
    		getApplicationListURL: function(pServerURL, pDeviceId, pFilter, pRequestSuffix) {
            	var url = pServerURL + 
		  	          "service/device/" + 
		  	           pDeviceId + "/" + 
		  	          pRequestSuffix +
		  	          "?t=" + new Date().getTime() + 
		  	          pFilter;
            	return url;
    		},
    		
    		getFeedbackURL: function(pServerURL, pApp) {
    			return pServerURL + "service/application/feedback/" + pApp.os + "/" + pApp.pkg + "/" + pApp.version;
    		},
    		
    		xhrGet : function (pArgs) {	
		    	console.log("xhrGet calling |" + pArgs.url + "| " + pArgs.sync);
			    
		    	
		    	//if (device.name === "IRDRT") //motorola XOOM 
		    	//{		    		
		    		if (!pArgs.headers) {
		    			pArgs.headers = {};
		    		}
		    		pArgs.headers.Authorization = this._getBase64Auth(pArgs.user, pArgs.password);  
		    		pArgs.user = null;
		    		pArgs.password = null;
		    	//} 

		    	
		    	xhr.get(pArgs);
    		}, 
    		
    		xhrPost : function (pArgs) {	
		    	console.log("xhrPost calling |" + pArgs.url + "| " + pArgs.sync);
			    
		    	//if (device.name === "IRDRT") //motorola XOOM 
		    	//{		    		
		    		if (!pArgs.headers) {
		    			pArgs.headers = {};
		    		}
		    		pArgs.headers.Authorization = this._getBase64Auth(pArgs.user, pArgs.password);  
		    		pArgs.user = null;
		    		pArgs.passowrd = null;
		    	//} 

		    	
		    	xhr.post(pArgs);
    		}
    };

    return com.ibm.mobile.appcenter.Connection;
});
